; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    szCmpi6 PROTO :DWORD,:DWORD,:DWORD
    szCmpi5 PROTO :DWORD,:DWORD,:DWORD

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL hmem  :DWORD
    LOCAL hbuf  :DWORD
    LOCAL flen  :DWORD
    LOCAL add1  :DWORD
    LOCAL add2  :DWORD
    LOCAL add3  :DWORD

    mov add1, 0
    mov add2, 0
    mov add3, 0

    invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_TIME_CRITICAL

    mov hmem, InputFile("\masm32\include\windows.inc")
    mov flen, ecx
    mov hbuf, alloc(flen)
    invoke MemCopy,hmem,hbuf,flen

    ;mov hmem, lcase$(hmem) ;************************  commented this out for test
    mov hbuf, ucase$(hbuf)

    push edi
    mov edi, 16

    invoke Sleep, 1000

  lp1:

  ; -------------------------------------------

    invoke GetTickCount
    push eax

    push esi
    mov esi, 30

  @@:
    invoke szCmpi6,hmem,hbuf,flen
    sub esi, 1
    jnz @B

    pop esi

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add add2, eax

    print str$(eax)," MS szCmpi6",13,10

  ; -------------------------------------------

    invoke Sleep, 1000

    invoke GetTickCount
    push eax

    push esi
    mov esi, 30

  @@:
    invoke szCmpi5,hmem,hbuf,flen
    sub esi, 1
    jnz @B

    pop esi

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add add3, eax

    print str$(eax)," MS szCmpi5",13,10

    invoke Sleep, 1000


  ; -------------------------------------------

    sub edi, 1
    jnz lp1

    invoke SetThreadPriority,rv(GetCurrentThread),THREAD_PRIORITY_NORMAL

    shr add1, 4
    shr add2, 4
    shr add3, 4

    print chr$(13,10)
    print str$(add2)," MS average for szCmpi6",13,10
    print str$(add3)," MS average for szCmpi5",13,10
    print chr$(13,10)

    free hmem
    free hbuf

    mov eax, input("Press ENTER to exit")

    ret

main endp

; 

; 

    .data
    align 16
      tbl \
      db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
      db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
      db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
      db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
      db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
      db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
      db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
      db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
      db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
      db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
      db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
      db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
      db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
      db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
      db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
    .code

; 

align 4

szCmpixx proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov eax, -1
    mov esi, src
    mov edi, dst

  align 4
  @@:
    add eax, 1
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    mov cl, [ebx+tbl]
    cmp cl, [edx+tbl]
    jne miss
    cmp eax, ln
    jl @B

    sub eax, eax
    jmp quit

  miss:
    add eax, 1

  quit:
    pop edi
    pop esi
    pop ebx

    ret

szCmpixx endp

; 
 ; 
 ; align 16
 ; 
 ; szCmpixx proc src:DWORD,dst:DWORD,ln:DWORD
 ; 
 ;     push ebx
 ;     push esi
 ;     push edi
 ; 
 ;     mov esi, src
 ;     mov edi, dst
 ; 
 ;     mov eax, ln
 ;     add esi, eax
 ;     add edi, eax
 ;     neg eax
 ; 
 ;   align 4
 ;   @@:
 ;     add eax, 1
 ;     jz quit
 ;     movzx edx, BYTE PTR [esi+eax]
 ;     movzx ebx, BYTE PTR [edi+eax]
 ;     mov cl, [edx+tbl]
 ;     cmp cl, [ebx+tbl]
 ;     je @B
 ; 
 ;     sub eax, eax
 ;     jmp quit
 ; 
 ;   miss:
 ;     add eax, 1
 ; 
 ;   quit:
 ;     pop edi
 ;     pop esi
 ;     pop ebx
 ; 
 ;     ret
 ; 
 ; szCmpixx endp
 ; 
; 

align 16

szCmpi5 proc src:DWORD,dst:DWORD,ln:DWORD

    sub eax, eax
    cmp eax, ln                     ; just quit on zero length
    je done
    push ebx
    push esi
    push edi

    mov esi, src
    mov edi, dst

  align 4
  @@:
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    mov cl, [edx+tbl]
    add eax, 1                      ; setup eax for next, or miss number if nomatch
    cmp cl, [ebx+tbl]
    jne quit
    cmp eax,ln
    jb @b

    sub eax, eax

  quit:
    pop edi
    pop esi
    pop ebx
  done:
    ret

szCmpi5 endp

align 16
szCmpi6 proc src:DWORD,dst:DWORD,ln:DWORD

    sub eax, eax
    cmp eax, ln                     ; just quit on zero length
    je done
    push ebx
    push esi
    push edi

    mov esi, src
    mov edi, dst

  align 4
  @@:
    movzx edx, BYTE PTR [esi+eax]
    movzx ebx, BYTE PTR [edi+eax]
    add eax, 1                      ; setup eax for next, or miss number if nomatch
    cmp edx,ebx
    je	xx
    mov cl, [edx+tbl]
    cmp cl, [ebx+tbl]
    jne quit
xx:
    cmp eax,ln
    jb @b

    sub eax, eax

  quit:
    pop edi
    pop esi
    pop ebx
  done:
    ret

szCmpi6 endp

; 

end start
